﻿using Microsoft.Win32.SafeHandles;
using System;
using System.ComponentModel;
using System.Runtime.InteropServices;

namespace PoC_IumMachineCert_EoP
{
    internal class SafeLsaLogonHandle : SafeHandleZeroOrMinusOneIsInvalid
    {
        [DllImport("Secur32.dll")]
        private static extern int LsaDeregisterLogonProcess(
          IntPtr LsaHandle
        );

        [DllImport("Secur32.dll")]
        private static extern int LsaConnectUntrusted(out SafeLsaLogonHandle handle);

        [DllImport("Secur32.dll", CharSet = CharSet.Unicode)]
        private static extern int LsaCallAuthenticationPackage(
              SafeLsaLogonHandle LsaHandle,
              uint AuthenticationPackage,
              IntPtr ProtocolSubmitBuffer,
              int SubmitBufferLength,
              out SafeLsaReturnBufferHandle ProtocolReturnBuffer,
              out int ReturnBufferLength,
              out int ProtocolStatus
        );

        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi)]
        internal class LsaString
        {
            public ushort Length;
            public ushort MaximumLength;
            [MarshalAs(UnmanagedType.LPStr)]
            string Buffer;

            public LsaString(string str)
            {
                Length = (ushort)str.Length;
                MaximumLength = (ushort)(str.Length + 1);
                Buffer = str;
            }
        }

        [DllImport("Secur32.dll")]
        internal static extern int LsaLookupAuthenticationPackage(SafeLsaLogonHandle LsaHandle, 
            LsaString PackageName, out uint AuthenticationPackage);

        public SafeLsaLogonHandle(IntPtr handle, bool ownsHandle) : base(ownsHandle)
        {
            SetHandle(handle);
        }

        public SafeLsaLogonHandle() : base(true)
        {
        }

        protected override bool ReleaseHandle()
        {
            return LsaDeregisterLogonProcess(handle) == 0;
        }

        internal static SafeLsaLogonHandle ConnectUntrusted()
        {
            var result = LsaConnectUntrusted(out SafeLsaLogonHandle hlsa);
            if (result < 0)
                throw new Win32Exception(result);
            return hlsa;
        }

        private uint LookupAuthPackage(string auth_package)
        {
            int result = LsaLookupAuthenticationPackage(this, new LsaString(auth_package), out uint auth_pkg);
            if (result < 0)
                throw new Win32Exception(result);
            return auth_pkg;
        }

        public SafeLsaReturnBufferHandle CallPackage(string auth_package, IntPtr buffer, int length)
        {
            uint pkg = LookupAuthPackage(auth_package);
            int result = LsaCallAuthenticationPackage(this, pkg, buffer, length,
                out SafeLsaReturnBufferHandle ret, out int ret_length, out int status);
            if (result < 0)
                throw new Win32Exception(result);
            if (status < 0)
                throw new Win32Exception(status);
            ret.Initialize((ulong)ret_length);
            return ret;
        }
    }
}
